 
//Copyright (C) 1998-2015 MKTMK Moscow, Russia
//http://sourceforge.net/projects/obasic/
//http://mktmk.narod.ru
//e-mail: mktmk<at>narod.ru
//e-mail: openbasicsoft<at>gmail.com
//interpreter Open Basic (OB).

#include <ob.h>

namespace OB_NAMESPACE_FOR_OB{

//here is ob_obasic::function and read-only static member

ob_type_char ob_type_namestatic::zero_object=0;

const ob_type_small_char*        ob_obasic::aboutmsg    =
OB_STRINGDEFINE("(C)1998-2012 MKTMK Open Basic. www.mktmk.narod.ru mktmk@narod.ru");

const ob_type_serialnum    ob_obasic::sernum=101;
const ob_type_version      ob_obasic::ver   =OB_VERSION_DEF;

ob_obasic::typeend ob_obasic::run1(){

ob_api* funcptr;
ob_savewrapper left;
ob_par par;

if(baselex.iszero()==true){
te=NOLOADEND;
}//if
else{

baselex.get_lex();

for(;;){

if(endoperatordetect==true){
baselex.putbacklex();
te=ENDOPERATORDETECT;
goto m1;
}//if

switch(baselex.gettypecurrentlex()){

case ob_lex::FUNC://call function without save return value
funcptr=baselex.getcurrentfunction();
par.work(&baselex);
left.clear();
funcptr->run(this,&par,&left);
left.clear();
baselex.get_lex();
break;

case ob_lex::OPERATOR:

tmpoperator=baselex.getcurrentoperator();

baselex.get_lex();
baselex.putbacklex();//for nextlex enquire

tmpoperator->runbefore(this);

tmpoperator->run_for_work(&baselex);

tmpoperator->runafter(this);

break;

case ob_lex::OLDARRAY:
case ob_lex::OLDVARIABLE:
case ob_lex::NEWNAME:
baselex.workvariable(baselex.extractvar()->get());
break;

case ob_lex::EOL:
if(stepflag==ob_obasic::STEP){
te=EOLEND;
goto m1;
}//if

case ob_lex::LABEL://in this level this is label
case ob_lex::DECINTNUMBER://in this level this is label
baselex.get_lex();
break;

case ob_lex::BREAKPOINT:
te=BREAKPOINTEND;
goto m1;

case ob_lex::ENDPROGRAMM:
te=ENDFILEEND;
goto m1;

default:
OB_ERR(ob_err3)
break;
}//switch
}//for(;;)

}//else

m1://exit for breakpoint token or step flag

return te;
}

ob_operator* ob_obasic::findoperator(ob_type_namestatic* namestatic){

ob_type_statictablesize j;
for(j=0;j!=ob_maxnumoperator;++j){

  ob_operator* current=&(tableoperator[j]);

  if(*((ob_type_namestatic*)(current))==ob_EMPTYkwrd) return OB_NULL;

  if(*((ob_type_namestatic*)(current))==(*namestatic)){
  return current;
  }//if

}//for
return OB_NULL;
}

#define OB_ADD(name1,name2)           ob_operator(name1,name2);
#define OB_ADD1(name1,name2,name3)    ob_operator(name1,name2,name3);

#ifndef OB_USER_WCHAR

#define OB_SETFUN(name1,name2)        setfun((ob_type_char*)name1,name2);
#define OB_SETFUN1(name1,name2,name3) setfun((ob_type_char*)name1,name2,name3);

#define OB_KWRDDEF(xxx)                       \
ob_##xxx##kwrd.set((ob_type_char*)#xxx,sizeof(#xxx));

#else

#define OB_SETFUN(name1,name2)        setfun((ob_type_char*)L##name1,name2);
#define OB_SETFUN1(name1,name2,name3) setfun((ob_type_char*)L##name1,name2,name3);

#define OB_KWRDDEF(xxx)                       \
ob_##xxx##kwrd.set((ob_type_char*)L#xxx,sizeof(L#xxx));

#endif

ob_obasic::ob_obasic():

table_system(ob_hashlength),
table_project(ob_hashlength),
table_default_subroutine(ob_hashlength,ob_hashlength_local_object),

baselex(OB_NULL),
readlex(OB_NULL),
read_from_file_lex(OB_NULL),
datalex(OB_NULL),
datastream(OB_NULL),
maxnestedgosub(OB_MAX_NESTED_GOSUB_DEFAULT)
{

baselex.set_basic_ptr(this);
readlex.set_basic_ptr(this);
read_from_file_lex.set_basic_ptr(this);
datalex.set_basic_ptr(this);

OB_KWRDDEF(THEN)
OB_KWRDDEF(TO)
OB_KWRDDEF(STEP)
OB_KWRDDEF(OUTPUT)
OB_KWRDDEF(AS)
OB_KWRDDEF(FILE)
ob_type_namestatic ob_EMPTYkwrd;

#ifdef OB_USER_WCHAR
ob_SHARPkwrd.set((ob_type_char*)L"#",sizeof(L"#"));
#else
ob_SHARPkwrd.set((ob_type_char*)"#",sizeof("#"));
#endif

//keywords as operator's name
OB_KWRDDEF(PRINT)
OB_KWRDDEF(INPUT)
OB_KWRDDEF(IF)
OB_KWRDDEF(FOR)
OB_KWRDDEF(NEXT)
OB_KWRDDEF(GOTO)
OB_KWRDDEF(GOSUB)
OB_KWRDDEF(RETURN)
OB_KWRDDEF(LET)
OB_KWRDDEF(DIM)
OB_KWRDDEF(STOP)
OB_KWRDDEF(END)
OB_KWRDDEF(REM)
OB_KWRDDEF(OPEN)
OB_KWRDDEF(CLOSE)
OB_KWRDDEF(KILL)
OB_KWRDDEF(READ)
OB_KWRDDEF(DATA)
OB_KWRDDEF(RESTORE)
OB_KWRDDEF(RANDOMIZE)
OB_KWRDDEF(ELSE)
OB_KWRDDEF(ENDIF)

//for version 1.91
OB_KWRDDEF(SUB)
OB_KWRDDEF(ENDSUB)
OB_KWRDDEF(EXITSUB)
OB_KWRDDEF(CHECKLOAD)
OB_KWRDDEF(VAR)

//it is problem with initialization order if tableoperator still global
tableoperator[0]=OB_ADD(&ob_IFkwrd,&ob_lex::operif)                                                 
tableoperator[1]=OB_ADD(&ob_ELSEkwrd,&ob_lex::operelse)
tableoperator[2]=OB_ADD(&ob_ENDIFkwrd,&ob_lex::operendif)
tableoperator[3]=OB_ADD(&ob_GOTOkwrd,&ob_lex::opergoto)
tableoperator[4]=OB_ADD(&ob_GOSUBkwrd,&ob_lex::opergosub)
tableoperator[5]=OB_ADD(&ob_RETURNkwrd,&ob_lex::operreturn)
tableoperator[6]=OB_ADD(&ob_FORkwrd,&ob_lex::operfor)
tableoperator[7]=OB_ADD(&ob_NEXTkwrd,&ob_lex::opernext)
tableoperator[8]=OB_ADD(&ob_PRINTkwrd,&ob_lex::operprint)
tableoperator[9]=OB_ADD(&ob_INPUTkwrd,&ob_lex::operinput)
tableoperator[10]=OB_ADD(&ob_DIMkwrd,&ob_lex::operdim)
tableoperator[11]=OB_ADD1(&ob_REMkwrd,&ob_lex::operrem,&ob_lex::operrem)
tableoperator[12]=OB_ADD(&ob_KILLkwrd,&ob_lex::operkill)
tableoperator[13]=OB_ADD(&ob_READkwrd,&ob_lex::operread)
tableoperator[14]=OB_ADD(&ob_DATAkwrd,&ob_lex::operdata)
tableoperator[15]=OB_ADD(&ob_RESTOREkwrd,&ob_lex::operrestore)
tableoperator[16]=OB_ADD(&ob_RANDOMIZEkwrd,&ob_lex::operrandomize)

//for version 1.91
tableoperator[17]=OB_ADD(&ob_SUBkwrd,&ob_lex::opersub)
tableoperator[18]=OB_ADD(&ob_ENDSUBkwrd,&ob_lex::operendsub)
tableoperator[19]=OB_ADD(&ob_EXITSUBkwrd,&ob_lex::operexitsub)
tableoperator[20]=OB_ADD1(&ob_CHECKLOADkwrd,&ob_lex::opercheckload_run,&ob_lex::opercheckload_load)
tableoperator[21]=OB_ADD(&ob_STOPkwrd,&ob_lex::operstop)
tableoperator[22]=OB_ADD(&ob_ENDkwrd,&ob_lex::operend)
tableoperator[23]=OB_ADD(&ob_LETkwrd,&ob_lex::operlet)

//for version 1.92
#ifdef OB_USER_FILE_OPERATION_OFF
tableoperator[24]=ob_operator();                    //last operator (end table indicator)
#else
tableoperator[24]=OB_ADD(&ob_OPENkwrd,&ob_lex::operopen)
tableoperator[25]=OB_ADD(&ob_CLOSEkwrd,&ob_lex::operclose)
tableoperator[26]=ob_operator();                    //last operator (end table indicator)
#endif

OB_SETFUN("RND",ob_fun_rnd)                           //1
OB_SETFUN("ABS",ob_fun_abs)                           //2
OB_SETFUN("SIN",ob_fun_sin)                           //3
OB_SETFUN("COS",ob_fun_cos)                           //4
OB_SETFUN("ATN",ob_fun_atn)                           //5
OB_SETFUN("SQR",ob_fun_sqr)                           //6
OB_SETFUN("EXP",ob_fun_exp)                           //7
OB_SETFUN("LOG",ob_fun_log)                           //8
OB_SETFUN("LOG10",ob_fun_log10)                       //9
OB_SETFUN("STR2FLOAT",str2flo)                        //10
OB_SETFUN("STR2INT%",str2int)                         //11
OB_SETFUN("INT%",ob_fun_int)                          //12
OB_SETFUN("SGN%",ob_fun_sgn)                          //13
OB_SETFUN("LEN%",ob_fun_len)                          //14
OB_SETFUN1("DAT$",ob_fun_dat,OB_DELETE)               //15
OB_SETFUN1("CLK$",ob_fun_clk,OB_DELETE)               //16
OB_SETFUN1("D2STR$",ob_fun_digit2str,OB_DELETE)       //17
OB_SETFUN1("D2HEXSTR$",ob_fun_digit2hexstr,OB_DELETE) //18

setstep(NOSTEP);
}

ob_obasic::loadresult ob_obasic::load1(ob_type_istreamcommon* i,ob_type_char* id){

set_flag_checkload(false);

if(i==OB_NULL) return STREAM_NULL;

ob_type_ostrstream datastream1;
ob_type_standartstring st;

baselex.get_input_stream()->set_stream(i);

//find label       and store it in       tablelabel 
//find local label and store it in local tablelabel
ob_type_streampos one(baselex.getposition());

if(id==OB_NULL) id=ob_EMPTYkwrd.getdata();

if(get_default_subroutine()->create_local_table(ob_hashlength,baselex.get_input_stream(),id)==false) return STREAM_DUPLICATE;

for(;;){

ob_type_streampos mbl;

for(;;){
mbl=baselex.getposition();
baselex.get_lex();

if(baselex.gettypecurrentlex()==ob_lex::BAD) OB_ERR(ob_err94);

if((baselex.gettypecurrentlex()==ob_lex::OPERATOR)&&((*baselex.getstring())==ob_CHECKLOADkwrd)){
baselex.getcurrentoperator()->run_for_load(&baselex);
if(get_flag_checkload()==true) return CHECKLOAD_DUPLICATE;
//CHECKLOAD operator 
}//if

if((baselex.gettypecurrentlex()==ob_lex::OPERATOR)&&((*baselex.getstring())==ob_REMkwrd)){
baselex.getcurrentoperator()->run_for_load(&baselex);
//REM operator must leave currentlex ENDPROGRAMM or EOL
}//if

if(baselex.gettypecurrentlex()==ob_lex::LABEL){

ob_data_for_jump_local*  current=get_default_subroutine()->findlabel(baselex.getstring(),baselex.get_input_stream());

if(current==OB_NULL){
get_default_subroutine()->put_label(baselex.getstring(),mbl,baselex.get_input_stream());
}//if
else{
OB_ERR(ob_err10);
}//else
}//if

if(baselex.gettypecurrentlex()==ob_lex::ENDPROGRAMM) goto m1;
if(baselex.gettypecurrentlex()==ob_lex::EOL) break;
}//for

baselex.get_lex();

ob_lex::typelex cl=baselex.gettypecurrentlex();

if(cl==ob_lex::DECINTNUMBER){

ob_data_for_jump_local*  current=get_default_subroutine()->findlabel(baselex.getstring(),baselex.get_input_stream());

if(current==OB_NULL){
get_default_subroutine()->put_label(baselex.getstring(),mbl,baselex.get_input_stream());
}//if
else{
OB_ERR(ob_err10);
}//else
}//if
else{
baselex.putbacklex();
}//else
}//for

m1:

//------------------------------ DATA stream create

baselex.setposition(one);

for(;;){
baselex.get_lex();

if((baselex.gettypecurrentlex()==ob_lex::OPERATOR)&&((*baselex.getstring())==ob_REMkwrd)){
baselex.getcurrentoperator()->run_for_work(&baselex);
continue;
}//if

if(baselex.gettypecurrentlex()==ob_lex::ENDPROGRAMM) break;

if(((*baselex.getstring())==ob_DATAkwrd)&&(baselex.gettypecurrentlex()==ob_lex::OPERATOR)){

for(;;){

baselex.get_lex();

if(baselex.gettypecurrentlex()==ob_lex::ENDPROGRAMM) goto m2;

if(baselex.gettypecurrentlex()==ob_lex::EOL){
datastream1<<ob_const_comma;
break;
}//if

datastream1<<baselex.getstring()->c_str();
}//for

}//if

}//for

m2:

datastream1<<ends;

if(datastream==OB_NULL) datastream= new ob_type_shortstrstream;

st=datastream1.str();

ob_wstream_to_stream(datastream,&st);

datalex.get_input_stream()->set_stream((ob_type_istreamcommon*)datastream);
datalex.restore();

baselex.setposition(one);

te=DUMMYEND;
endoperatordetect=false;

return LOAD_OK;
}//load

}//end namespace 

